#INCLUDE START.H
LPARAMETERS tcStub AS String
IF !EMPTY(tcStub)
	*      
	MESSAGEBOX(APPLICATION_PARAMETERS, 64, APPLICATION_NAME)
	RETURN
ENDIF
TRY
	PRIVATE goStart AS Form
	LOCAL loException AS Exception, lcPathFile AS String, lcDefault AS String,;
		loIniFile AS Custom, lcTargetFile AS String, llSuccess AS Logical,;
		lcSourcePath AS String, lcTargetPath AS String, lnFolders AS Integer
	ON SHUTDOWN QUIT
	SET SAFETY OFF		&&    
	SET DELETED ON		&&    
	SET DATE TO DMY		&&     //
	SET HOURS TO 24		&&   DATETIME()
	SET SECONDS ON		&&   DATETIME()
	*     APPLICATION_NAME
	lcPathFile = SYS(16, PROGRAM(-1))
	*    APPLICATION_NAME
	lcDefault = ADDBS(JUSTPATH(lcPathFile))
	*    
	Application.DefaultFilePath = lcDefault
	DO CASE
	CASE AlreadyRunning(lcPathFile)
		*   
		MESSAGEBOX(ERR_ALREADYRUNNING + CHR_CR + lcPathFile, 64, APPLICATION_NAME)
	CASE !FILE(APPLICATION_BASE)
		*     
		MESSAGEBOX(ERR_FILEDBFNOTFOUND + CHR_CR + lcDefault + APPLICATION_BASE, 48, APPLICATION_NAME)
	OTHERWISE
		*   INI 
		loIniFile = NEWOBJECT('cstIniFile', 'Start', '', lcDefault)
		DO CASE
		CASE VARTYPE(loIniFile) # 'O'
		CASE !EMPTY(loIniFile.cSourceFile) AND !FILE(loIniFile.cSourceFile)
			*   -
			MESSAGEBOX(ERR_SOURCEFILENOTFOUND + CHR_CR + loIniFile.cSourceFile, 48, APPLICATION_NAME)
		CASE !EMPTY(loIniFile.cTargetPath) AND !DIRECTORY(loIniFile.cTargetPath)
			*    
			MESSAGEBOX(ERR_TARGETPATHNOTFOUND + CHR_CR + loIniFile.cTargetPath, 48, APPLICATION_NAME)
		OTHERWISE
			llSuccess = .T.
			lcTargetFile = ''
			*   
			WITH loIniFile
				IF !EMPTY(.cSourceFile)
					lcTargetFile = IIF(!EMPTY(.cTargetPath),;
						ADDBS(.cTargetPath), lcDefault) + JUSTFNAME(.cSourceFile)
					TRY
						COPY FILE (.cSourceFile) TO (lcTargetFile)
					CATCH
						*     
						*    
						MESSAGEBOX(ERR_COPYSOURCETOTARGET + CHR_CR + .cSourceFile + ' -> ' +;
							lcTargetFile + CHR_CR + ERR_ALREADYSTARTED, 64, APPLICATION_NAME)
						llSuccess = .F.
					ENDTRY
				ENDIF
			ENDWITH
			IF llSuccess
				*  ...
				DO FORM Start NAME goStart LINKED
				IF VARTYPE(goStart) = 'O'
					WITH goStart
						USE APPLICATION_BASE
						COUNT FOR !EMPTY(cSource) TO lnFolders
						*  
						IF lnFolders > 0
							.oleProgressOperation.Max = lnFolders * 5
							llSuccess = .F.
							SET TEXTMERGE ON
							SET TEXTMERGE TO APPLICATION_LOG NOSHOW
							\\<<TRANSFORM(DATETIME())>>
							SCAN FOR !EMPTY(cSource)
								lcSourcePath = ADDBS(UPPER(ALLTRIM(cSource)))
								lcTargetPath = ADDBS(UPPER(ALLTRIM(cTarget)))
								*  ...  ...  ...  ...  ...
								llSuccess = .CloneFolder(lcSourcePath, lcTargetPath, lcDefault)
								IF !llSuccess
									EXIT
								ENDIF
							ENDSCAN
							\<<TRANSFORM(DATETIME())>>
							SET TEXTMERGE TO
						ELSE
							IF EMPTY(lcTargetFile)
								*  START.DBF 
								MESSAGEBOX(ERR_TABLEISEMPTY, 64, APPLICATION_NAME)
							ENDIF
						ENDIF
						*  
						IF llSuccess
							IF !EMPTY(lcTargetFile)
								*  ...
								.ShowOperMessage(MSG_OPERATIONEXECUTE)
								.ShowFileMessage(lcTargetFile)
								.RunProgram(lcTargetFile)
							ENDIF
						ENDIF
						*  ...
						.ShowOperMessage(MSG_OPERATIONQUIT)
						.ShowFileMessage('')
						.Release()
					ENDWITH			
				ENDIF
			ENDIF
		ENDCASE
	ENDCASE
CATCH TO loException
	*    
	DO ShowError WITH loException
	IF Application.StartMode = 0 AND VARTYPE(goStart) = 'O'
		goStart.Release()
	ENDIF
ENDTRY

*    

PROCEDURE ShowError
LPARAMETERS toException AS Exception
LOCAL lcErrorNo AS String, lcMessage AS String, lcStackLevel AS String,;
	lcProcedure AS String, lcLineNo AS String, lcLineContents AS String
TRY
	*  
	lcErrorNo = MSG_ERRORNO + CHR_TAB + ': ' + TRANSFORM(toException.ErrorNo) + CHR_CR
	* 
	lcMessage = MSG_ERRORMESSAGE + CHR_TAB + ': ' + toException.Message + CHR_CR
	*  
	lcStackLevel = MSG_ERRORSTACKLEVEL + CHR_TAB + ': ' + TRANSFORM(toException.StackLevel) + CHR_CR
	* 
	lcProcedure	= MSG_ERRORPROCEDURE + CHR_TAB + ': ' + toException.Procedure + CHR_CR
	*  
	lcLineNo = MSG_ERRORLINENO + CHR_TAB + ': ' + TRANSFORM(toException.LineNo)
	*  
	lcLineContents = IIF(Application.Startmode = 0,;
		CHR_CR + MSG_ERRORLINECONTENTS + CHR_TAB + ': ' + toException.LineContents, '')
	*  
	MESSAGEBOX(lcErrorNo + lcMessage + lcStackLevel +;
		lcProcedure + lcLineNo + lcLineContents, 16, APPLICATION_NAME)
CATCH
	*       
	MESSAGEBOX(MSG_ERRORCYCLE, 16, APPLICATION_NAME)
ENDTRY
RETURN

*   

FUNCTION AlreadyRunning
LPARAMETERS tcPathFile AS String
LOCAL lnError AS Integer
tcPathFile = CHRTRAN(tcPathFile, '\', '_')
DECLARE INTEGER CreateMutex IN WIN32API INTEGER, INTEGER, STRING
*      
CreateMutex(0, 1, tcPathFile)
*  
DECLARE INTEGER GetLastError IN WIN32API
lnError = GetLastError()
CLEAR DLLS 'GetLastError', 'CreateMutex'
IF lnError = MUTEX_INVALIDHANDLE
	*     
	MESSAGEBOX(MUTEX_CREATEERROR, 64, APPLICATION_NAME)
	*     
	RETURN .F.
ENDIF
RETURN lnError = MUTEX_ALREADYEXISTS
